'use strict';

exports.__esModule = true;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _scrollToLink = require('./scroll-to-link');

var _scrollToLink2 = _interopRequireDefault(_scrollToLink);

var _helpers = require('../helpers');

var _navigation = require('../../src/styles/navigation.css');

var _navigation2 = _interopRequireDefault(_navigation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SecondaryNavigationItem = function SecondaryNavigationItem(_ref) {
    var url = _ref.url,
        openInNewWindow = _ref.openInNewWindow,
        text = _ref.text;
    return _react2.default.createElement(
        'a',
        {
            className: _navigation2.default.secondaryLink,
            href: url,
            target: openInNewWindow ? '_blank' : '_self'
        },
        text
    );
};

var SecondaryNavigation = function SecondaryNavigation(_ref2) {
    var secondaryNavigationLinks = _ref2.secondaryNavigationLinks;
    return _react2.default.createElement(
        'div',
        { className: _navigation2.default.secondary },
        _react2.default.createElement(
            'div',
            { className: 'container' },
            _react2.default.createElement(
                'div',
                { className: 'row' },
                secondaryNavigationLinks.map(function (link, i) {
                    return _react2.default.createElement(SecondaryNavigationItem, (0, _extends3.default)({}, link, { key: i }));
                })
            )
        )
    );
};

var NavLink = function NavLink(props) {
    var url = props.url,
        label = props.label,
        isCurrent = props.isCurrent,
        openInNewWindow = props.openInNewWindow;

    return _react2.default.createElement(
        'li',
        null,
        _react2.default.createElement(
            'a',
            {
                href: url,
                className: isCurrent ? 'nav-link-current' : null,
                target: openInNewWindow ? '_blank' : '_self'
            },
            label
        )
    );
};

var NavLinks = function NavLinks(props) {
    var className = props.className,
        navigationItems = props.navigationItems;

    return _react2.default.createElement(
        'ul',
        { className: className },
        navigationItems && navigationItems.map(function (item, i) {
            return _react2.default.createElement(NavLink, {
                key: i,
                url: item.url,
                label: item.label,
                isCurrent: item.isCurrent,
                openInNewWindow: item.openInNewWindow
            });
        }),
        props.showContact && _react2.default.createElement(
            'li',
            null,
            _react2.default.createElement(
                _scrollToLink2.default,
                {
                    href: '#contact-form',
                    className: 'hidden-sm hidden-md hidden-lg'
                },
                props.contactLabel
            )
        ),
        props.includeSecondaryLinks && props.secondaryNavigationLinks.map(function (link, i) {
            return _react2.default.createElement(
                'li',
                { key: i },
                _react2.default.createElement(SecondaryNavigationItem, link)
            );
        })
    );
};

var _ref3 = _react2.default.createElement(
    'span',
    { className: 'sr-only' },
    'Toggle navigation'
);

var _ref4 = _react2.default.createElement('i', { className: 'fa fa-bars', 'aria-hidden': 'true' });

var Navigation = function (_React$Component) {
    (0, _inherits3.default)(Navigation, _React$Component);

    function Navigation() {
        (0, _classCallCheck3.default)(this, Navigation);

        var _this = (0, _possibleConstructorReturn3.default)(this, _React$Component.call(this));

        _this.state = { open: false };
        return _this;
    }

    Navigation.prototype.componentDidMount = function componentDidMount() {
        var _this2 = this;

        // Initialize Sticky Header
        if (this._navbar) {
            (0, _jquery2.default)(this._navbar).affix({
                offset: {
                    top: this.props.affixOffset
                }
            });
        }

        if (this._sideMenuToggle) {
            (0, _jquery2.default)(this._sideMenuToggle).sidr({
                side: 'right',
                onOpen: function onOpen() {
                    return _this2.setState({ open: true });
                },
                onClose: function onClose() {
                    return _this2.setState({ open: false });
                }
            });
        }
    };

    Navigation.prototype.render = function render() {
        var _this3 = this;

        var _props = this.props,
            showSecondaryNavigation = _props.showSecondaryNavigation,
            logoHeader = _props.logoHeader,
            logoUrl = _props.logoUrl,
            logoHeaderAltAttr = _props.logoHeaderAltAttr,
            contactLabel = _props.contactLabel,
            showContact = _props.showContact;

        return _react2.default.createElement(
            'div',
            null,
            showSecondaryNavigation && _react2.default.createElement(SecondaryNavigation, this.props),
            _react2.default.createElement(
                'div',
                { className: _navigation2.default.navbar },
                _react2.default.createElement(
                    'div',
                    {
                        ref: function ref(c) {
                            return _this3._navbar = c;
                        },
                        className: _navigation2.default.navbarSection
                    },
                    _react2.default.createElement(
                        'div',
                        { className: _navigation2.default['hsct-container'] },
                        _react2.default.createElement(
                            'div',
                            { className: 'row' },
                            _react2.default.createElement(
                                'nav',
                                { className: _navigation2.default['hsct-navbar'], role: 'navigation' },
                                _react2.default.createElement(
                                    'div',
                                    { className: _navigation2.default['hsct-navbar-header'] },
                                    _react2.default.createElement(
                                        'button',
                                        {
                                            type: 'button',
                                            className: _navigation2.default['hsct-navbar-toggle'],
                                            ref: function ref(e) {
                                                return _this3._sideMenuToggle = e;
                                            }
                                        },
                                        _ref3,
                                        this.state.open ? 'Close' : _ref4
                                    ),
                                    _react2.default.createElement(
                                        'a',
                                        { href: logoUrl, className: _navigation2.default['hsct-navbar-brand'] },
                                        _react2.default.createElement('img', {
                                            src: logoHeader,
                                            alt: logoHeaderAltAttr
                                        })
                                    )
                                ),
                                showContact && _react2.default.createElement(
                                    _scrollToLink2.default,
                                    {
                                        href: '#contact-form',
                                        className: 'btn btn-navigation-contact-us btn-hs hs-smooth-scroll',
                                        animationTime: 500
                                    },
                                    contactLabel
                                ),
                                _react2.default.createElement(NavLinks, (0, _extends3.default)({ className: 'nav ' + _navigation2.default['hsct-container'] }, this.props))
                            )
                        )
                    )
                )
            ),
            _react2.default.createElement(
                'div',
                { id: 'sidr' },
                _react2.default.createElement(NavLinks, (0, _extends3.default)({}, this.props, { includeSecondaryLinks: true }))
            )
        );
    };

    return Navigation;
}(_react2.default.Component);

exports.default = Navigation;


Navigation.propTypes = {
    secondaryNavigationLinks: _react.PropTypes.arrayOf(_react.PropTypes.shape({
        url: _react.PropTypes.string,
        openInNewWindow: _react.PropTypes.bool,
        text: _react.PropTypes.string
    })).isRequired,
    navigationItems: _react.PropTypes.arrayOf(_react.PropTypes.shape({
        url: _react.PropTypes.string.isRequired,
        label: _react.PropTypes.string.isRequired,
        openInNewWindow: _react.PropTypes.bool,
        isCurrent: _react.PropTypes.bool
    })).isRequired,
    showSecondaryNavigation: _react.PropTypes.bool.isRequired,
    baseLink: _react.PropTypes.string.isRequired,
    hasTeamMembers: _react.PropTypes.bool,
    logoHeader: _react.PropTypes.string.isRequired,
    logoUrl: _react.PropTypes.string,
    logoHeaderAltAttr: _react.PropTypes.string.isRequired,
    showHome: _react.PropTypes.bool,
    showProducts: _react.PropTypes.bool,
    showEvents: _react.PropTypes.bool,
    showNews: _react.PropTypes.bool,
    showAboutMePage: _react.PropTypes.bool,
    contactLabel: _react.PropTypes.string,
    showContact: _react.PropTypes.bool,
    affixOffset: _react.PropTypes.number
};

Navigation.defaultProps = {
    contactLabel: "Contact",
    showContact: true
};

var mapStateToProps = function mapStateToProps(state, props) {
    return {
        showSecondaryNavigation: (0, _helpers.selectBoxIsTrue)(state.theme_data.show_secondary_navigation),
        secondaryNavigationLinks: (state.theme_data.secondary_navigation_links || []).map(function (link) {
            return (0, _assign2.default)({ openInNewWindow: (0, _helpers.selectBoxIsTrue)(link.open_in_new_window) }, link);
        }),
        baseLink: state.base_link,
        hasTeamMembers: state.profile.team_members && Boolean(state.profile.team_members.length),
        logoHeader: state.theme_data.logo_header,
        logoUrl: state.theme_data.logo_url,
        logoHeaderAltAttr: state.theme_data.footer_logo_image_alt_attr,
        navigationItems: (state.theme_data.navigation.links || []).map(function (item) {
            return {
                url: (0, _helpers.selectBoxIsTrue)(item.is_external) ? item.url : '' + state.base_link + item.url,
                label: item.text,
                openInNewWindow: (0, _helpers.selectBoxIsTrue)(item.open_in_new_window),
                isCurrent: props.currentPage === item.url
            };
        }),
        contactLabel: state.theme_data.contact_form.title,
        affixOffset: 40
    };
};