'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ScrollToLink = function (_React$Component) {
    (0, _inherits3.default)(ScrollToLink, _React$Component);

    function ScrollToLink() {
        (0, _classCallCheck3.default)(this, ScrollToLink);

        var _this = (0, _possibleConstructorReturn3.default)(this, _React$Component.call(this));

        _this.initializeSmoothScroll = _this.initializeSmoothScroll.bind(_this);
        return _this;
    }

    ScrollToLink.prototype.initializeSmoothScroll = function initializeSmoothScroll(e) {
        var href = (0, _jquery2.default)(e.target).attr('href');
        var animationTime = this.props.animationTime || 0;

        if (href.length && href[0] === '#') {
            e.preventDefault();

            var target = (0, _jquery2.default)(href);
            if (target.length) {
                (0, _jquery2.default)('html, body').animate({
                    scrollTop: target.offset().top - this.computeOffsetTop()
                }, animationTime);
            }
        }
    };

    ScrollToLink.prototype.computeOffsetTop = function computeOffsetTop() {
        var $nav = (0, _jquery2.default)('.navbar-section');
        // Offset by height of the fixed navigation
        return $nav.length ? $nav.height() : 0;
    };

    ScrollToLink.prototype.render = function render() {
        var _this2 = this;

        return _react2.default.createElement(
            'a',
            {
                href: this.props.href,
                className: this.props.className,
                ref: function ref(c) {
                    return _this2._link = c;
                },
                onClick: this.initializeSmoothScroll
            },
            this.props.children
        );
    };

    return ScrollToLink;
}(_react2.default.Component);

exports.default = ScrollToLink;


ScrollToLink.propTypes = {
    animationTime: _react2.default.PropTypes.number
};