'use strict';

exports.__esModule = true;
exports.dedent = exports.selectBoxIsTrue = exports.Style = exports.DotDotDot = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// wrap the jQuery plugin in a react component
// there are React dotdotdot plugins, but using the jQuery one to preserve truncation appearance
var DotDotDot = exports.DotDotDot = function (_React$Component) {
    (0, _inherits3.default)(DotDotDot, _React$Component);

    function DotDotDot() {
        (0, _classCallCheck3.default)(this, DotDotDot);
        return (0, _possibleConstructorReturn3.default)(this, _React$Component.apply(this, arguments));
    }

    DotDotDot.prototype.componentDidMount = function componentDidMount() {
        this._element && (0, _jquery2.default)(this._element).dotdotdot();
    };

    DotDotDot.prototype.render = function render() {
        var _this2 = this;

        return _react2.default.createElement(
            'div',
            null,
            _react2.default.cloneElement(this.props.children, { ref: function ref(e) {
                    return _this2._element = e;
                } })
        );
    };

    return DotDotDot;
}(_react2.default.Component);

DotDotDot.propTypes = {
    children: _react.PropTypes.element
};

// For inserting dynamic styles
// Appends the children of the component (which must be a string of CSS) to the head element
// Use es6 multi-line strings (``) to maintain your sanity

var Style = exports.Style = function (_React$Component2) {
    (0, _inherits3.default)(Style, _React$Component2);

    function Style() {
        (0, _classCallCheck3.default)(this, Style);

        var _this3 = (0, _possibleConstructorReturn3.default)(this, _React$Component2.call(this));

        var styleNode = document.createElement('style');
        styleNode.type = 'text/css';
        _this3._styleNode = styleNode;
        return _this3;
    }

    Style.prototype.componentDidMount = function componentDidMount() {
        var head = document.getElementsByTagName('head')[0];
        head.appendChild(this._styleNode);
    };

    Style.prototype.render = function render() {
        this._styleNode.innerHTML = this.props.children;
        return null;
    };

    return Style;
}(_react2.default.Component);

Style.propTypes = {
    children: _react.PropTypes.string.isRequired
};

// there are lots of checks for arr[0] === "true" due to select box inputs
// storing the data as a string array
var selectBoxIsTrue = exports.selectBoxIsTrue = function selectBoxIsTrue(value) {
    return value && value[0] === "true";
};

// tag that removes indentation and newlines from template strings
var dedent = exports.dedent = function dedent(strs) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
    }

    return _underscore2.default.flatten(_underscore2.default.zip(strs.map(function (s) {
        return s.replace(/\s\s+/g, ' ');
    }), args)).join('');
};