import React from 'react';
import $ from 'jquery';

export default class ScrollToLink extends React.Component {
    constructor(){
        super();
        this.initializeSmoothScroll = this.initializeSmoothScroll.bind(this);
    }

    initializeSmoothScroll(e) {
        const href = $(e.target).attr('href');
        const animationTime = this.props.animationTime || 0;

        if(href.length && href[0] === '#') {
            e.preventDefault();

            const target = $(href);
            if (target.length) {
                $('html, body').animate({
                    scrollTop: target.offset().top - this.computeOffsetTop()
                }, animationTime );
            }
        }
    }

    computeOffsetTop(){
        const $nav = $('.navbar-section');
        // Offset by height of the fixed navigation
        return $nav.length ? $nav.height() : 0;
    }

    render(){
        return (
            <a
                href={this.props.href}
                className={this.props.className}
                ref={(c) => this._link = c}
                onClick={this.initializeSmoothScroll}
            >
                {this.props.children}
            </a>
        );
    }
}

ScrollToLink.propTypes = {
    animationTime: React.PropTypes.number
};
